module Ecs.Spec exposing
    ( Spec, ComponentSpec
    , Ecs1, spec1, components1
    , Ecs2, spec2, components2
    , Ecs3, spec3, components3
    , Ecs4, spec4, components4
    , Ecs5, spec5, components5
    , Ecs6, spec6, components6
    , Ecs7, spec7, components7
    , Ecs8, spec8, components8
    , Ecs9, spec9, components9
    , Ecs10, spec10, components10
    , Ecs11, spec11, components11
    , Ecs12, spec12, components12
    , Ecs13, spec13, components13
    , Ecs14, spec14, components14
    , Ecs15, spec15, components15
    , Ecs16, spec16, components16
    , Ecs17, spec17, components17
    , Ecs18, spec18, components18
    , Ecs19, spec19, components19
    , Ecs20, spec20, components20
    , Ecs21, spec21, components21
    , Ecs22, spec22, components22
    , Ecs23, spec23, components23
    , Ecs24, spec24, components24
    , Ecs25, spec25, components25
    , Ecs26, spec26, components26
    , Ecs27, spec27, components27
    , Ecs28, spec28, components28
    , Ecs29, spec29, components29
    , Ecs30, spec30, components30
    , Ecs31, spec31, components31
    , Ecs32, spec32, components32
    , Ecs33, spec33, components33
    , Ecs34, spec34, components34
    , Ecs35, spec35, components35
    , Ecs36, spec36, components36
    , Ecs37, spec37, components37
    , Ecs38, spec38, components38
    , Ecs39, spec39, components39
    , Ecs40, spec40, components40
    , Ecs41, spec41, components41
    , Ecs42, spec42, components42
    , Ecs43, spec43, components43
    , Ecs44, spec44, components44
    , Ecs45, spec45, components45
    , Ecs46, spec46, components46
    , Ecs47, spec47, components47
    , Ecs48, spec48, components48
    , Ecs49, spec49, components49
    , Ecs50, spec50, components50
    )

{-|

@docs Spec, ComponentSpec
@docs Ecs1, spec1, components1
@docs Ecs2, spec2, components2
@docs Ecs3, spec3, components3
@docs Ecs4, spec4, components4
@docs Ecs5, spec5, components5
@docs Ecs6, spec6, components6
@docs Ecs7, spec7, components7
@docs Ecs8, spec8, components8
@docs Ecs9, spec9, components9
@docs Ecs10, spec10, components10
@docs Ecs11, spec11, components11
@docs Ecs12, spec12, components12
@docs Ecs13, spec13, components13
@docs Ecs14, spec14, components14
@docs Ecs15, spec15, components15
@docs Ecs16, spec16, components16
@docs Ecs17, spec17, components17
@docs Ecs18, spec18, components18
@docs Ecs19, spec19, components19
@docs Ecs20, spec20, components20
@docs Ecs21, spec21, components21
@docs Ecs22, spec22, components22
@docs Ecs23, spec23, components23
@docs Ecs24, spec24, components24
@docs Ecs25, spec25, components25
@docs Ecs26, spec26, components26
@docs Ecs27, spec27, components27
@docs Ecs28, spec28, components28
@docs Ecs29, spec29, components29
@docs Ecs30, spec30, components30
@docs Ecs31, spec31, components31
@docs Ecs32, spec32, components32
@docs Ecs33, spec33, components33
@docs Ecs34, spec34, components34
@docs Ecs35, spec35, components35
@docs Ecs36, spec36, components36
@docs Ecs37, spec37, components37
@docs Ecs38, spec38, components38
@docs Ecs39, spec39, components39
@docs Ecs40, spec40, components40
@docs Ecs41, spec41, components41
@docs Ecs42, spec42, components42
@docs Ecs43, spec43, components43
@docs Ecs44, spec44, components44
@docs Ecs45, spec45, components45
@docs Ecs46, spec46, components46
@docs Ecs47, spec47, components47
@docs Ecs48, spec48, components48
@docs Ecs49, spec49, components49
@docs Ecs50, spec50, components50

-}

import Dict exposing (Dict)
import Ecs.Internal as Internal
import Set


{-| The ecs specification type.
-}
type alias Spec comparable ecs =
    Internal.Spec comparable ecs


{-| A component specification type.
-}
type alias ComponentSpec comparable ecs a =
    Internal.ComponentSpec comparable ecs a


{-| An ecs model type with 1 component type.
-}
type Ecs1 comparable a1
    = Ecs1
        { data1 : Dict comparable a1
        }


{-| An ecs specification with 1 component type.
-}
spec1 : Spec comparable (Ecs1 comparable a1)
spec1 =
    Internal.Spec
        { empty =
            Ecs1
                { data1 = Dict.empty
                }
        , clear =
            \id (Ecs1 ecs) ->
                Ecs1
                    { data1 = Dict.remove id ecs.data1
                    }
        , isEmpty =
            \(Ecs1 ecs) ->
                Dict.isEmpty ecs.data1
        , componentCount =
            \(Ecs1 ecs) ->
                Dict.size ecs.data1
        , ids =
            \(Ecs1 ecs) ->
                [ Dict.keys ecs.data1
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs1 ecs) ->
                Dict.member id ecs.data1
        }


{-| Create component specifications for an ecs with 1 component type.
-}
components1 :
    (ComponentSpec comparable (Ecs1 comparable a1) a1
     -> componentSpecs
    )
    -> componentSpecs
components1 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs1 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs1 ecs) ->
                    Ecs1
                        { data1 = updateFn ecs.data1
                        }
            }
        )


{-| An ecs model type with 2 component types.
-}
type Ecs2 comparable a1 a2
    = Ecs2
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        }


{-| An ecs specification with 2 component types.
-}
spec2 : Spec comparable (Ecs2 comparable a1 a2)
spec2 =
    Internal.Spec
        { empty =
            Ecs2
                { data1 = Dict.empty
                , data2 = Dict.empty
                }
        , clear =
            \id (Ecs2 ecs) ->
                Ecs2
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    }
        , isEmpty =
            \(Ecs2 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
        , componentCount =
            \(Ecs2 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
        , ids =
            \(Ecs2 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs2 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
        }


{-| Create component specifications for an ecs with 2 component types.
-}
components2 :
    (ComponentSpec comparable (Ecs2 comparable a1 a2) a1
     -> ComponentSpec comparable (Ecs2 comparable a1 a2) a2
     -> componentSpecs
    )
    -> componentSpecs
components2 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs2 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs2 ecs) ->
                    Ecs2
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs2 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs2 ecs) ->
                    Ecs2
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        }
            }
        )


{-| An ecs model type with 3 component types.
-}
type Ecs3 comparable a1 a2 a3
    = Ecs3
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        }


{-| An ecs specification with 3 component types.
-}
spec3 : Spec comparable (Ecs3 comparable a1 a2 a3)
spec3 =
    Internal.Spec
        { empty =
            Ecs3
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                }
        , clear =
            \id (Ecs3 ecs) ->
                Ecs3
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    }
        , isEmpty =
            \(Ecs3 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
        , componentCount =
            \(Ecs3 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
        , ids =
            \(Ecs3 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs3 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
        }


{-| Create component specifications for an ecs with 3 component types.
-}
components3 :
    (ComponentSpec comparable (Ecs3 comparable a1 a2 a3) a1
     -> ComponentSpec comparable (Ecs3 comparable a1 a2 a3) a2
     -> ComponentSpec comparable (Ecs3 comparable a1 a2 a3) a3
     -> componentSpecs
    )
    -> componentSpecs
components3 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs3 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs3 ecs) ->
                    Ecs3
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs3 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs3 ecs) ->
                    Ecs3
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs3 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs3 ecs) ->
                    Ecs3
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        }
            }
        )


{-| An ecs model type with 4 component types.
-}
type Ecs4 comparable a1 a2 a3 a4
    = Ecs4
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        }


{-| An ecs specification with 4 component types.
-}
spec4 : Spec comparable (Ecs4 comparable a1 a2 a3 a4)
spec4 =
    Internal.Spec
        { empty =
            Ecs4
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                }
        , clear =
            \id (Ecs4 ecs) ->
                Ecs4
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    }
        , isEmpty =
            \(Ecs4 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
        , componentCount =
            \(Ecs4 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
        , ids =
            \(Ecs4 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs4 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
        }


{-| Create component specifications for an ecs with 4 component types.
-}
components4 :
    (ComponentSpec comparable (Ecs4 comparable a1 a2 a3 a4) a1
     -> ComponentSpec comparable (Ecs4 comparable a1 a2 a3 a4) a2
     -> ComponentSpec comparable (Ecs4 comparable a1 a2 a3 a4) a3
     -> ComponentSpec comparable (Ecs4 comparable a1 a2 a3 a4) a4
     -> componentSpecs
    )
    -> componentSpecs
components4 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs4 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs4 ecs) ->
                    Ecs4
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs4 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs4 ecs) ->
                    Ecs4
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs4 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs4 ecs) ->
                    Ecs4
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs4 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs4 ecs) ->
                    Ecs4
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        }
            }
        )


{-| An ecs model type with 5 component types.
-}
type Ecs5 comparable a1 a2 a3 a4 a5
    = Ecs5
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        }


{-| An ecs specification with 5 component types.
-}
spec5 : Spec comparable (Ecs5 comparable a1 a2 a3 a4 a5)
spec5 =
    Internal.Spec
        { empty =
            Ecs5
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                }
        , clear =
            \id (Ecs5 ecs) ->
                Ecs5
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    }
        , isEmpty =
            \(Ecs5 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
        , componentCount =
            \(Ecs5 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
        , ids =
            \(Ecs5 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs5 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
        }


{-| Create component specifications for an ecs with 5 component types.
-}
components5 :
    (ComponentSpec comparable (Ecs5 comparable a1 a2 a3 a4 a5) a1
     -> ComponentSpec comparable (Ecs5 comparable a1 a2 a3 a4 a5) a2
     -> ComponentSpec comparable (Ecs5 comparable a1 a2 a3 a4 a5) a3
     -> ComponentSpec comparable (Ecs5 comparable a1 a2 a3 a4 a5) a4
     -> ComponentSpec comparable (Ecs5 comparable a1 a2 a3 a4 a5) a5
     -> componentSpecs
    )
    -> componentSpecs
components5 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs5 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs5 ecs) ->
                    Ecs5
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs5 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs5 ecs) ->
                    Ecs5
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs5 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs5 ecs) ->
                    Ecs5
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs5 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs5 ecs) ->
                    Ecs5
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs5 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs5 ecs) ->
                    Ecs5
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        }
            }
        )


{-| An ecs model type with 6 component types.
-}
type Ecs6 comparable a1 a2 a3 a4 a5 a6
    = Ecs6
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        }


{-| An ecs specification with 6 component types.
-}
spec6 : Spec comparable (Ecs6 comparable a1 a2 a3 a4 a5 a6)
spec6 =
    Internal.Spec
        { empty =
            Ecs6
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                }
        , clear =
            \id (Ecs6 ecs) ->
                Ecs6
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    }
        , isEmpty =
            \(Ecs6 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
        , componentCount =
            \(Ecs6 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
        , ids =
            \(Ecs6 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs6 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
        }


{-| Create component specifications for an ecs with 6 component types.
-}
components6 :
    (ComponentSpec comparable (Ecs6 comparable a1 a2 a3 a4 a5 a6) a1
     -> ComponentSpec comparable (Ecs6 comparable a1 a2 a3 a4 a5 a6) a2
     -> ComponentSpec comparable (Ecs6 comparable a1 a2 a3 a4 a5 a6) a3
     -> ComponentSpec comparable (Ecs6 comparable a1 a2 a3 a4 a5 a6) a4
     -> ComponentSpec comparable (Ecs6 comparable a1 a2 a3 a4 a5 a6) a5
     -> ComponentSpec comparable (Ecs6 comparable a1 a2 a3 a4 a5 a6) a6
     -> componentSpecs
    )
    -> componentSpecs
components6 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs6 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs6 ecs) ->
                    Ecs6
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs6 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs6 ecs) ->
                    Ecs6
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs6 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs6 ecs) ->
                    Ecs6
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs6 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs6 ecs) ->
                    Ecs6
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs6 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs6 ecs) ->
                    Ecs6
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs6 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs6 ecs) ->
                    Ecs6
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        }
            }
        )


{-| An ecs model type with 7 component types.
-}
type Ecs7 comparable a1 a2 a3 a4 a5 a6 a7
    = Ecs7
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        }


{-| An ecs specification with 7 component types.
-}
spec7 : Spec comparable (Ecs7 comparable a1 a2 a3 a4 a5 a6 a7)
spec7 =
    Internal.Spec
        { empty =
            Ecs7
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                }
        , clear =
            \id (Ecs7 ecs) ->
                Ecs7
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    }
        , isEmpty =
            \(Ecs7 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
        , componentCount =
            \(Ecs7 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
        , ids =
            \(Ecs7 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs7 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
        }


{-| Create component specifications for an ecs with 7 component types.
-}
components7 :
    (ComponentSpec comparable (Ecs7 comparable a1 a2 a3 a4 a5 a6 a7) a1
     -> ComponentSpec comparable (Ecs7 comparable a1 a2 a3 a4 a5 a6 a7) a2
     -> ComponentSpec comparable (Ecs7 comparable a1 a2 a3 a4 a5 a6 a7) a3
     -> ComponentSpec comparable (Ecs7 comparable a1 a2 a3 a4 a5 a6 a7) a4
     -> ComponentSpec comparable (Ecs7 comparable a1 a2 a3 a4 a5 a6 a7) a5
     -> ComponentSpec comparable (Ecs7 comparable a1 a2 a3 a4 a5 a6 a7) a6
     -> ComponentSpec comparable (Ecs7 comparable a1 a2 a3 a4 a5 a6 a7) a7
     -> componentSpecs
    )
    -> componentSpecs
components7 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs7 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs7 ecs) ->
                    Ecs7
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs7 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs7 ecs) ->
                    Ecs7
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs7 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs7 ecs) ->
                    Ecs7
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs7 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs7 ecs) ->
                    Ecs7
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs7 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs7 ecs) ->
                    Ecs7
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs7 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs7 ecs) ->
                    Ecs7
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs7 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs7 ecs) ->
                    Ecs7
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        }
            }
        )


{-| An ecs model type with 8 component types.
-}
type Ecs8 comparable a1 a2 a3 a4 a5 a6 a7 a8
    = Ecs8
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        }


{-| An ecs specification with 8 component types.
-}
spec8 : Spec comparable (Ecs8 comparable a1 a2 a3 a4 a5 a6 a7 a8)
spec8 =
    Internal.Spec
        { empty =
            Ecs8
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                }
        , clear =
            \id (Ecs8 ecs) ->
                Ecs8
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    }
        , isEmpty =
            \(Ecs8 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
        , componentCount =
            \(Ecs8 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
        , ids =
            \(Ecs8 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs8 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
        }


{-| Create component specifications for an ecs with 8 component types.
-}
components8 :
    (ComponentSpec comparable (Ecs8 comparable a1 a2 a3 a4 a5 a6 a7 a8) a1
     -> ComponentSpec comparable (Ecs8 comparable a1 a2 a3 a4 a5 a6 a7 a8) a2
     -> ComponentSpec comparable (Ecs8 comparable a1 a2 a3 a4 a5 a6 a7 a8) a3
     -> ComponentSpec comparable (Ecs8 comparable a1 a2 a3 a4 a5 a6 a7 a8) a4
     -> ComponentSpec comparable (Ecs8 comparable a1 a2 a3 a4 a5 a6 a7 a8) a5
     -> ComponentSpec comparable (Ecs8 comparable a1 a2 a3 a4 a5 a6 a7 a8) a6
     -> ComponentSpec comparable (Ecs8 comparable a1 a2 a3 a4 a5 a6 a7 a8) a7
     -> ComponentSpec comparable (Ecs8 comparable a1 a2 a3 a4 a5 a6 a7 a8) a8
     -> componentSpecs
    )
    -> componentSpecs
components8 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs8 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs8 ecs) ->
                    Ecs8
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs8 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs8 ecs) ->
                    Ecs8
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs8 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs8 ecs) ->
                    Ecs8
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs8 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs8 ecs) ->
                    Ecs8
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs8 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs8 ecs) ->
                    Ecs8
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs8 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs8 ecs) ->
                    Ecs8
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs8 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs8 ecs) ->
                    Ecs8
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs8 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs8 ecs) ->
                    Ecs8
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        }
            }
        )


{-| An ecs model type with 9 component types.
-}
type Ecs9 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9
    = Ecs9
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        }


{-| An ecs specification with 9 component types.
-}
spec9 : Spec comparable (Ecs9 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9)
spec9 =
    Internal.Spec
        { empty =
            Ecs9
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                }
        , clear =
            \id (Ecs9 ecs) ->
                Ecs9
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    }
        , isEmpty =
            \(Ecs9 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
        , componentCount =
            \(Ecs9 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
        , ids =
            \(Ecs9 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs9 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
        }


{-| Create component specifications for an ecs with 9 component types.
-}
components9 :
    (ComponentSpec comparable (Ecs9 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9) a1
     -> ComponentSpec comparable (Ecs9 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9) a2
     -> ComponentSpec comparable (Ecs9 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9) a3
     -> ComponentSpec comparable (Ecs9 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9) a4
     -> ComponentSpec comparable (Ecs9 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9) a5
     -> ComponentSpec comparable (Ecs9 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9) a6
     -> ComponentSpec comparable (Ecs9 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9) a7
     -> ComponentSpec comparable (Ecs9 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9) a8
     -> ComponentSpec comparable (Ecs9 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9) a9
     -> componentSpecs
    )
    -> componentSpecs
components9 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs9 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs9 ecs) ->
                    Ecs9
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs9 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs9 ecs) ->
                    Ecs9
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs9 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs9 ecs) ->
                    Ecs9
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs9 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs9 ecs) ->
                    Ecs9
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs9 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs9 ecs) ->
                    Ecs9
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs9 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs9 ecs) ->
                    Ecs9
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs9 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs9 ecs) ->
                    Ecs9
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs9 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs9 ecs) ->
                    Ecs9
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs9 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs9 ecs) ->
                    Ecs9
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        }
            }
        )


{-| An ecs model type with 10 component types.
-}
type Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10
    = Ecs10
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        }


{-| An ecs specification with 10 component types.
-}
spec10 : Spec comparable (Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10)
spec10 =
    Internal.Spec
        { empty =
            Ecs10
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                }
        , clear =
            \id (Ecs10 ecs) ->
                Ecs10
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    }
        , isEmpty =
            \(Ecs10 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
        , componentCount =
            \(Ecs10 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
        , ids =
            \(Ecs10 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs10 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
        }


{-| Create component specifications for an ecs with 10 component types.
-}
components10 :
    (ComponentSpec comparable (Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10) a1
     -> ComponentSpec comparable (Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10) a2
     -> ComponentSpec comparable (Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10) a3
     -> ComponentSpec comparable (Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10) a4
     -> ComponentSpec comparable (Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10) a5
     -> ComponentSpec comparable (Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10) a6
     -> ComponentSpec comparable (Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10) a7
     -> ComponentSpec comparable (Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10) a8
     -> ComponentSpec comparable (Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10) a9
     -> ComponentSpec comparable (Ecs10 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10) a10
     -> componentSpecs
    )
    -> componentSpecs
components10 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs10 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs10 ecs) ->
                    Ecs10
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs10 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs10 ecs) ->
                    Ecs10
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs10 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs10 ecs) ->
                    Ecs10
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs10 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs10 ecs) ->
                    Ecs10
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs10 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs10 ecs) ->
                    Ecs10
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs10 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs10 ecs) ->
                    Ecs10
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs10 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs10 ecs) ->
                    Ecs10
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs10 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs10 ecs) ->
                    Ecs10
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs10 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs10 ecs) ->
                    Ecs10
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs10 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs10 ecs) ->
                    Ecs10
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        }
            }
        )


{-| An ecs model type with 11 component types.
-}
type Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11
    = Ecs11
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        }


{-| An ecs specification with 11 component types.
-}
spec11 : Spec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11)
spec11 =
    Internal.Spec
        { empty =
            Ecs11
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                }
        , clear =
            \id (Ecs11 ecs) ->
                Ecs11
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    }
        , isEmpty =
            \(Ecs11 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
        , componentCount =
            \(Ecs11 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
        , ids =
            \(Ecs11 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs11 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
        }


{-| Create component specifications for an ecs with 11 component types.
-}
components11 :
    (ComponentSpec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11) a1
     -> ComponentSpec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11) a2
     -> ComponentSpec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11) a3
     -> ComponentSpec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11) a4
     -> ComponentSpec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11) a5
     -> ComponentSpec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11) a6
     -> ComponentSpec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11) a7
     -> ComponentSpec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11) a8
     -> ComponentSpec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11) a9
     -> ComponentSpec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11) a10
     -> ComponentSpec comparable (Ecs11 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11) a11
     -> componentSpecs
    )
    -> componentSpecs
components11 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs11 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs11 ecs) ->
                    Ecs11
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs11 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs11 ecs) ->
                    Ecs11
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs11 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs11 ecs) ->
                    Ecs11
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs11 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs11 ecs) ->
                    Ecs11
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs11 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs11 ecs) ->
                    Ecs11
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs11 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs11 ecs) ->
                    Ecs11
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs11 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs11 ecs) ->
                    Ecs11
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs11 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs11 ecs) ->
                    Ecs11
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs11 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs11 ecs) ->
                    Ecs11
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs11 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs11 ecs) ->
                    Ecs11
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs11 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs11 ecs) ->
                    Ecs11
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        }
            }
        )


{-| An ecs model type with 12 component types.
-}
type Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12
    = Ecs12
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        }


{-| An ecs specification with 12 component types.
-}
spec12 : Spec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12)
spec12 =
    Internal.Spec
        { empty =
            Ecs12
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                }
        , clear =
            \id (Ecs12 ecs) ->
                Ecs12
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    }
        , isEmpty =
            \(Ecs12 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
        , componentCount =
            \(Ecs12 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
        , ids =
            \(Ecs12 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs12 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
        }


{-| Create component specifications for an ecs with 12 component types.
-}
components12 :
    (ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a1
     -> ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a2
     -> ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a3
     -> ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a4
     -> ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a5
     -> ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a6
     -> ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a7
     -> ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a8
     -> ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a9
     -> ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a10
     -> ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a11
     -> ComponentSpec comparable (Ecs12 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12) a12
     -> componentSpecs
    )
    -> componentSpecs
components12 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs12 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs12 ecs) ->
                    Ecs12
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        }
            }
        )


{-| An ecs model type with 13 component types.
-}
type Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13
    = Ecs13
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        }


{-| An ecs specification with 13 component types.
-}
spec13 : Spec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13)
spec13 =
    Internal.Spec
        { empty =
            Ecs13
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                }
        , clear =
            \id (Ecs13 ecs) ->
                Ecs13
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    }
        , isEmpty =
            \(Ecs13 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
        , componentCount =
            \(Ecs13 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
        , ids =
            \(Ecs13 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs13 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
        }


{-| Create component specifications for an ecs with 13 component types.
-}
components13 :
    (ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a1
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a2
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a3
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a4
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a5
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a6
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a7
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a8
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a9
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a10
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a11
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a12
     -> ComponentSpec comparable (Ecs13 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13) a13
     -> componentSpecs
    )
    -> componentSpecs
components13 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs13 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs13 ecs) ->
                    Ecs13
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        }
            }
        )


{-| An ecs model type with 14 component types.
-}
type Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14
    = Ecs14
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        }


{-| An ecs specification with 14 component types.
-}
spec14 : Spec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14)
spec14 =
    Internal.Spec
        { empty =
            Ecs14
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                }
        , clear =
            \id (Ecs14 ecs) ->
                Ecs14
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    }
        , isEmpty =
            \(Ecs14 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
        , componentCount =
            \(Ecs14 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
        , ids =
            \(Ecs14 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs14 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
        }


{-| Create component specifications for an ecs with 14 component types.
-}
components14 :
    (ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a1
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a2
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a3
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a4
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a5
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a6
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a7
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a8
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a9
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a10
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a11
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a12
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a13
     -> ComponentSpec comparable (Ecs14 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14) a14
     -> componentSpecs
    )
    -> componentSpecs
components14 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs14 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs14 ecs) ->
                    Ecs14
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        }
            }
        )


{-| An ecs model type with 15 component types.
-}
type Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15
    = Ecs15
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        }


{-| An ecs specification with 15 component types.
-}
spec15 : Spec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15)
spec15 =
    Internal.Spec
        { empty =
            Ecs15
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                }
        , clear =
            \id (Ecs15 ecs) ->
                Ecs15
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    }
        , isEmpty =
            \(Ecs15 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
        , componentCount =
            \(Ecs15 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
        , ids =
            \(Ecs15 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs15 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
        }


{-| Create component specifications for an ecs with 15 component types.
-}
components15 :
    (ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a1
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a2
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a3
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a4
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a5
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a6
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a7
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a8
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a9
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a10
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a11
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a12
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a13
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a14
     -> ComponentSpec comparable (Ecs15 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15) a15
     -> componentSpecs
    )
    -> componentSpecs
components15 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs15 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs15 ecs) ->
                    Ecs15
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        }
            }
        )


{-| An ecs model type with 16 component types.
-}
type Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16
    = Ecs16
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        }


{-| An ecs specification with 16 component types.
-}
spec16 : Spec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16)
spec16 =
    Internal.Spec
        { empty =
            Ecs16
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                }
        , clear =
            \id (Ecs16 ecs) ->
                Ecs16
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    }
        , isEmpty =
            \(Ecs16 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
        , componentCount =
            \(Ecs16 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
        , ids =
            \(Ecs16 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs16 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
        }


{-| Create component specifications for an ecs with 16 component types.
-}
components16 :
    (ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a1
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a2
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a3
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a4
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a5
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a6
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a7
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a8
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a9
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a10
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a11
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a12
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a13
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a14
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a15
     -> ComponentSpec comparable (Ecs16 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16) a16
     -> componentSpecs
    )
    -> componentSpecs
components16 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs16 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs16 ecs) ->
                    Ecs16
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        }
            }
        )


{-| An ecs model type with 17 component types.
-}
type Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17
    = Ecs17
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        }


{-| An ecs specification with 17 component types.
-}
spec17 : Spec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17)
spec17 =
    Internal.Spec
        { empty =
            Ecs17
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                }
        , clear =
            \id (Ecs17 ecs) ->
                Ecs17
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    }
        , isEmpty =
            \(Ecs17 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
        , componentCount =
            \(Ecs17 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
        , ids =
            \(Ecs17 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs17 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
        }


{-| Create component specifications for an ecs with 17 component types.
-}
components17 :
    (ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a1
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a2
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a3
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a4
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a5
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a6
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a7
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a8
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a9
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a10
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a11
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a12
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a13
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a14
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a15
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a16
     -> ComponentSpec comparable (Ecs17 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17) a17
     -> componentSpecs
    )
    -> componentSpecs
components17 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs17 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs17 ecs) ->
                    Ecs17
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        }
            }
        )


{-| An ecs model type with 18 component types.
-}
type Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18
    = Ecs18
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        }


{-| An ecs specification with 18 component types.
-}
spec18 : Spec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18)
spec18 =
    Internal.Spec
        { empty =
            Ecs18
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                }
        , clear =
            \id (Ecs18 ecs) ->
                Ecs18
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    }
        , isEmpty =
            \(Ecs18 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
        , componentCount =
            \(Ecs18 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
        , ids =
            \(Ecs18 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs18 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
        }


{-| Create component specifications for an ecs with 18 component types.
-}
components18 :
    (ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a1
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a2
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a3
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a4
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a5
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a6
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a7
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a8
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a9
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a10
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a11
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a12
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a13
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a14
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a15
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a16
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a17
     -> ComponentSpec comparable (Ecs18 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18) a18
     -> componentSpecs
    )
    -> componentSpecs
components18 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs18 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs18 ecs) ->
                    Ecs18
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        }
            }
        )


{-| An ecs model type with 19 component types.
-}
type Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19
    = Ecs19
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        }


{-| An ecs specification with 19 component types.
-}
spec19 : Spec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19)
spec19 =
    Internal.Spec
        { empty =
            Ecs19
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                }
        , clear =
            \id (Ecs19 ecs) ->
                Ecs19
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    }
        , isEmpty =
            \(Ecs19 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
        , componentCount =
            \(Ecs19 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
        , ids =
            \(Ecs19 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs19 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
        }


{-| Create component specifications for an ecs with 19 component types.
-}
components19 :
    (ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a1
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a2
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a3
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a4
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a5
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a6
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a7
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a8
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a9
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a10
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a11
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a12
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a13
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a14
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a15
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a16
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a17
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a18
     -> ComponentSpec comparable (Ecs19 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19) a19
     -> componentSpecs
    )
    -> componentSpecs
components19 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs19 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs19 ecs) ->
                    Ecs19
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        }
            }
        )


{-| An ecs model type with 20 component types.
-}
type Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20
    = Ecs20
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        }


{-| An ecs specification with 20 component types.
-}
spec20 : Spec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20)
spec20 =
    Internal.Spec
        { empty =
            Ecs20
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                }
        , clear =
            \id (Ecs20 ecs) ->
                Ecs20
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    }
        , isEmpty =
            \(Ecs20 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
        , componentCount =
            \(Ecs20 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
        , ids =
            \(Ecs20 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs20 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
        }


{-| Create component specifications for an ecs with 20 component types.
-}
components20 :
    (ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a1
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a2
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a3
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a4
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a5
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a6
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a7
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a8
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a9
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a10
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a11
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a12
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a13
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a14
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a15
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a16
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a17
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a18
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a19
     -> ComponentSpec comparable (Ecs20 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20) a20
     -> componentSpecs
    )
    -> componentSpecs
components20 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs20 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs20 ecs) ->
                    Ecs20
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        }
            }
        )


{-| An ecs model type with 21 component types.
-}
type Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21
    = Ecs21
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        }


{-| An ecs specification with 21 component types.
-}
spec21 : Spec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21)
spec21 =
    Internal.Spec
        { empty =
            Ecs21
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                }
        , clear =
            \id (Ecs21 ecs) ->
                Ecs21
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    }
        , isEmpty =
            \(Ecs21 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
        , componentCount =
            \(Ecs21 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
        , ids =
            \(Ecs21 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs21 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
        }


{-| Create component specifications for an ecs with 21 component types.
-}
components21 :
    (ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a1
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a2
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a3
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a4
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a5
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a6
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a7
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a8
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a9
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a10
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a11
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a12
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a13
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a14
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a15
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a16
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a17
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a18
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a19
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a20
     -> ComponentSpec comparable (Ecs21 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21) a21
     -> componentSpecs
    )
    -> componentSpecs
components21 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs21 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs21 ecs) ->
                    Ecs21
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        }
            }
        )


{-| An ecs model type with 22 component types.
-}
type Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22
    = Ecs22
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        }


{-| An ecs specification with 22 component types.
-}
spec22 : Spec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22)
spec22 =
    Internal.Spec
        { empty =
            Ecs22
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                }
        , clear =
            \id (Ecs22 ecs) ->
                Ecs22
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    }
        , isEmpty =
            \(Ecs22 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
        , componentCount =
            \(Ecs22 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
        , ids =
            \(Ecs22 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs22 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
        }


{-| Create component specifications for an ecs with 22 component types.
-}
components22 :
    (ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a1
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a2
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a3
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a4
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a5
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a6
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a7
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a8
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a9
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a10
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a11
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a12
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a13
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a14
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a15
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a16
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a17
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a18
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a19
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a20
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a21
     -> ComponentSpec comparable (Ecs22 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22) a22
     -> componentSpecs
    )
    -> componentSpecs
components22 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs22 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs22 ecs) ->
                    Ecs22
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        }
            }
        )


{-| An ecs model type with 23 component types.
-}
type Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23
    = Ecs23
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        }


{-| An ecs specification with 23 component types.
-}
spec23 : Spec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23)
spec23 =
    Internal.Spec
        { empty =
            Ecs23
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                }
        , clear =
            \id (Ecs23 ecs) ->
                Ecs23
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    }
        , isEmpty =
            \(Ecs23 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
        , componentCount =
            \(Ecs23 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
        , ids =
            \(Ecs23 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs23 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
        }


{-| Create component specifications for an ecs with 23 component types.
-}
components23 :
    (ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a1
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a2
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a3
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a4
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a5
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a6
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a7
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a8
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a9
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a10
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a11
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a12
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a13
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a14
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a15
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a16
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a17
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a18
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a19
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a20
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a21
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a22
     -> ComponentSpec comparable (Ecs23 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23) a23
     -> componentSpecs
    )
    -> componentSpecs
components23 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs23 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs23 ecs) ->
                    Ecs23
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        }
            }
        )


{-| An ecs model type with 24 component types.
-}
type Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24
    = Ecs24
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        }


{-| An ecs specification with 24 component types.
-}
spec24 : Spec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24)
spec24 =
    Internal.Spec
        { empty =
            Ecs24
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                }
        , clear =
            \id (Ecs24 ecs) ->
                Ecs24
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    }
        , isEmpty =
            \(Ecs24 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
        , componentCount =
            \(Ecs24 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
        , ids =
            \(Ecs24 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs24 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
        }


{-| Create component specifications for an ecs with 24 component types.
-}
components24 :
    (ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a1
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a2
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a3
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a4
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a5
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a6
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a7
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a8
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a9
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a10
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a11
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a12
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a13
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a14
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a15
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a16
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a17
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a18
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a19
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a20
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a21
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a22
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a23
     -> ComponentSpec comparable (Ecs24 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24) a24
     -> componentSpecs
    )
    -> componentSpecs
components24 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs24 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs24 ecs) ->
                    Ecs24
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        }
            }
        )


{-| An ecs model type with 25 component types.
-}
type Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25
    = Ecs25
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        }


{-| An ecs specification with 25 component types.
-}
spec25 : Spec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25)
spec25 =
    Internal.Spec
        { empty =
            Ecs25
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                }
        , clear =
            \id (Ecs25 ecs) ->
                Ecs25
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    }
        , isEmpty =
            \(Ecs25 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
        , componentCount =
            \(Ecs25 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
        , ids =
            \(Ecs25 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs25 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
        }


{-| Create component specifications for an ecs with 25 component types.
-}
components25 :
    (ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a1
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a2
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a3
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a4
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a5
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a6
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a7
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a8
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a9
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a10
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a11
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a12
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a13
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a14
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a15
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a16
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a17
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a18
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a19
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a20
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a21
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a22
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a23
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a24
     -> ComponentSpec comparable (Ecs25 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25) a25
     -> componentSpecs
    )
    -> componentSpecs
components25 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs25 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs25 ecs) ->
                    Ecs25
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        }
            }
        )


{-| An ecs model type with 26 component types.
-}
type Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26
    = Ecs26
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        }


{-| An ecs specification with 26 component types.
-}
spec26 : Spec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26)
spec26 =
    Internal.Spec
        { empty =
            Ecs26
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                }
        , clear =
            \id (Ecs26 ecs) ->
                Ecs26
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    }
        , isEmpty =
            \(Ecs26 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
        , componentCount =
            \(Ecs26 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
        , ids =
            \(Ecs26 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs26 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
        }


{-| Create component specifications for an ecs with 26 component types.
-}
components26 :
    (ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a1
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a2
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a3
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a4
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a5
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a6
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a7
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a8
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a9
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a10
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a11
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a12
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a13
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a14
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a15
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a16
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a17
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a18
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a19
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a20
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a21
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a22
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a23
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a24
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a25
     -> ComponentSpec comparable (Ecs26 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26) a26
     -> componentSpecs
    )
    -> componentSpecs
components26 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs26 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs26 ecs) ->
                    Ecs26
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        }
            }
        )


{-| An ecs model type with 27 component types.
-}
type Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27
    = Ecs27
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        }


{-| An ecs specification with 27 component types.
-}
spec27 : Spec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27)
spec27 =
    Internal.Spec
        { empty =
            Ecs27
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                }
        , clear =
            \id (Ecs27 ecs) ->
                Ecs27
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    }
        , isEmpty =
            \(Ecs27 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
        , componentCount =
            \(Ecs27 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
        , ids =
            \(Ecs27 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs27 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
        }


{-| Create component specifications for an ecs with 27 component types.
-}
components27 :
    (ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a1
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a2
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a3
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a4
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a5
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a6
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a7
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a8
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a9
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a10
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a11
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a12
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a13
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a14
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a15
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a16
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a17
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a18
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a19
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a20
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a21
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a22
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a23
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a24
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a25
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a26
     -> ComponentSpec comparable (Ecs27 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27) a27
     -> componentSpecs
    )
    -> componentSpecs
components27 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs27 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs27 ecs) ->
                    Ecs27
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        }
            }
        )


{-| An ecs model type with 28 component types.
-}
type Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28
    = Ecs28
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        }


{-| An ecs specification with 28 component types.
-}
spec28 : Spec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28)
spec28 =
    Internal.Spec
        { empty =
            Ecs28
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                }
        , clear =
            \id (Ecs28 ecs) ->
                Ecs28
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    }
        , isEmpty =
            \(Ecs28 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
        , componentCount =
            \(Ecs28 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
        , ids =
            \(Ecs28 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs28 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
        }


{-| Create component specifications for an ecs with 28 component types.
-}
components28 :
    (ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a1
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a2
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a3
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a4
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a5
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a6
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a7
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a8
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a9
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a10
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a11
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a12
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a13
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a14
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a15
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a16
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a17
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a18
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a19
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a20
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a21
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a22
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a23
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a24
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a25
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a26
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a27
     -> ComponentSpec comparable (Ecs28 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28) a28
     -> componentSpecs
    )
    -> componentSpecs
components28 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs28 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs28 ecs) ->
                    Ecs28
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        }
            }
        )


{-| An ecs model type with 29 component types.
-}
type Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29
    = Ecs29
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        }


{-| An ecs specification with 29 component types.
-}
spec29 : Spec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29)
spec29 =
    Internal.Spec
        { empty =
            Ecs29
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                }
        , clear =
            \id (Ecs29 ecs) ->
                Ecs29
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    }
        , isEmpty =
            \(Ecs29 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
        , componentCount =
            \(Ecs29 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
        , ids =
            \(Ecs29 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs29 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
        }


{-| Create component specifications for an ecs with 29 component types.
-}
components29 :
    (ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a1
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a2
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a3
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a4
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a5
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a6
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a7
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a8
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a9
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a10
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a11
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a12
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a13
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a14
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a15
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a16
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a17
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a18
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a19
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a20
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a21
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a22
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a23
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a24
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a25
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a26
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a27
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a28
     -> ComponentSpec comparable (Ecs29 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29) a29
     -> componentSpecs
    )
    -> componentSpecs
components29 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs29 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs29 ecs) ->
                    Ecs29
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        }
            }
        )


{-| An ecs model type with 30 component types.
-}
type Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30
    = Ecs30
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        }


{-| An ecs specification with 30 component types.
-}
spec30 : Spec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30)
spec30 =
    Internal.Spec
        { empty =
            Ecs30
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                }
        , clear =
            \id (Ecs30 ecs) ->
                Ecs30
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    }
        , isEmpty =
            \(Ecs30 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
        , componentCount =
            \(Ecs30 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
        , ids =
            \(Ecs30 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs30 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
        }


{-| Create component specifications for an ecs with 30 component types.
-}
components30 :
    (ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a1
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a2
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a3
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a4
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a5
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a6
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a7
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a8
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a9
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a10
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a11
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a12
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a13
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a14
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a15
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a16
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a17
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a18
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a19
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a20
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a21
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a22
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a23
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a24
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a25
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a26
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a27
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a28
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a29
     -> ComponentSpec comparable (Ecs30 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30) a30
     -> componentSpecs
    )
    -> componentSpecs
components30 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs30 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs30 ecs) ->
                    Ecs30
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        }
            }
        )


{-| An ecs model type with 31 component types.
-}
type Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31
    = Ecs31
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        }


{-| An ecs specification with 31 component types.
-}
spec31 : Spec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31)
spec31 =
    Internal.Spec
        { empty =
            Ecs31
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                }
        , clear =
            \id (Ecs31 ecs) ->
                Ecs31
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    }
        , isEmpty =
            \(Ecs31 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
        , componentCount =
            \(Ecs31 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
        , ids =
            \(Ecs31 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs31 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
        }


{-| Create component specifications for an ecs with 31 component types.
-}
components31 :
    (ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a1
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a2
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a3
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a4
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a5
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a6
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a7
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a8
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a9
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a10
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a11
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a12
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a13
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a14
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a15
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a16
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a17
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a18
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a19
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a20
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a21
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a22
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a23
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a24
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a25
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a26
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a27
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a28
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a29
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a30
     -> ComponentSpec comparable (Ecs31 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31) a31
     -> componentSpecs
    )
    -> componentSpecs
components31 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs31 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs31 ecs) ->
                    Ecs31
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        }
            }
        )


{-| An ecs model type with 32 component types.
-}
type Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32
    = Ecs32
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        }


{-| An ecs specification with 32 component types.
-}
spec32 : Spec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32)
spec32 =
    Internal.Spec
        { empty =
            Ecs32
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                }
        , clear =
            \id (Ecs32 ecs) ->
                Ecs32
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    }
        , isEmpty =
            \(Ecs32 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
        , componentCount =
            \(Ecs32 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
        , ids =
            \(Ecs32 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs32 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
        }


{-| Create component specifications for an ecs with 32 component types.
-}
components32 :
    (ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a1
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a2
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a3
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a4
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a5
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a6
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a7
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a8
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a9
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a10
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a11
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a12
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a13
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a14
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a15
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a16
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a17
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a18
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a19
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a20
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a21
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a22
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a23
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a24
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a25
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a26
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a27
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a28
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a29
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a30
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a31
     -> ComponentSpec comparable (Ecs32 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32) a32
     -> componentSpecs
    )
    -> componentSpecs
components32 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs32 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs32 ecs) ->
                    Ecs32
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        }
            }
        )


{-| An ecs model type with 33 component types.
-}
type Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33
    = Ecs33
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        }


{-| An ecs specification with 33 component types.
-}
spec33 : Spec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33)
spec33 =
    Internal.Spec
        { empty =
            Ecs33
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                }
        , clear =
            \id (Ecs33 ecs) ->
                Ecs33
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    }
        , isEmpty =
            \(Ecs33 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
        , componentCount =
            \(Ecs33 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
        , ids =
            \(Ecs33 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs33 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
        }


{-| Create component specifications for an ecs with 33 component types.
-}
components33 :
    (ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a1
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a2
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a3
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a4
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a5
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a6
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a7
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a8
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a9
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a10
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a11
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a12
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a13
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a14
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a15
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a16
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a17
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a18
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a19
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a20
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a21
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a22
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a23
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a24
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a25
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a26
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a27
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a28
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a29
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a30
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a31
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a32
     -> ComponentSpec comparable (Ecs33 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33) a33
     -> componentSpecs
    )
    -> componentSpecs
components33 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs33 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs33 ecs) ->
                    Ecs33
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        }
            }
        )


{-| An ecs model type with 34 component types.
-}
type Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34
    = Ecs34
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        }


{-| An ecs specification with 34 component types.
-}
spec34 : Spec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34)
spec34 =
    Internal.Spec
        { empty =
            Ecs34
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                }
        , clear =
            \id (Ecs34 ecs) ->
                Ecs34
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    }
        , isEmpty =
            \(Ecs34 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
        , componentCount =
            \(Ecs34 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
        , ids =
            \(Ecs34 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs34 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
        }


{-| Create component specifications for an ecs with 34 component types.
-}
components34 :
    (ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a1
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a2
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a3
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a4
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a5
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a6
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a7
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a8
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a9
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a10
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a11
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a12
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a13
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a14
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a15
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a16
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a17
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a18
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a19
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a20
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a21
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a22
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a23
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a24
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a25
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a26
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a27
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a28
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a29
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a30
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a31
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a32
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a33
     -> ComponentSpec comparable (Ecs34 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34) a34
     -> componentSpecs
    )
    -> componentSpecs
components34 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs34 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs34 ecs) ->
                    Ecs34
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        }
            }
        )


{-| An ecs model type with 35 component types.
-}
type Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35
    = Ecs35
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        }


{-| An ecs specification with 35 component types.
-}
spec35 : Spec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35)
spec35 =
    Internal.Spec
        { empty =
            Ecs35
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                }
        , clear =
            \id (Ecs35 ecs) ->
                Ecs35
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    }
        , isEmpty =
            \(Ecs35 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
        , componentCount =
            \(Ecs35 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
        , ids =
            \(Ecs35 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs35 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
        }


{-| Create component specifications for an ecs with 35 component types.
-}
components35 :
    (ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a1
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a2
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a3
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a4
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a5
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a6
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a7
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a8
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a9
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a10
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a11
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a12
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a13
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a14
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a15
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a16
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a17
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a18
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a19
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a20
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a21
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a22
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a23
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a24
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a25
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a26
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a27
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a28
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a29
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a30
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a31
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a32
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a33
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a34
     -> ComponentSpec comparable (Ecs35 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35) a35
     -> componentSpecs
    )
    -> componentSpecs
components35 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs35 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs35 ecs) ->
                    Ecs35
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        }
            }
        )


{-| An ecs model type with 36 component types.
-}
type Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36
    = Ecs36
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        }


{-| An ecs specification with 36 component types.
-}
spec36 : Spec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36)
spec36 =
    Internal.Spec
        { empty =
            Ecs36
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                }
        , clear =
            \id (Ecs36 ecs) ->
                Ecs36
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    }
        , isEmpty =
            \(Ecs36 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
        , componentCount =
            \(Ecs36 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
        , ids =
            \(Ecs36 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs36 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
        }


{-| Create component specifications for an ecs with 36 component types.
-}
components36 :
    (ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a1
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a2
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a3
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a4
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a5
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a6
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a7
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a8
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a9
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a10
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a11
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a12
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a13
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a14
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a15
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a16
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a17
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a18
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a19
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a20
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a21
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a22
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a23
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a24
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a25
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a26
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a27
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a28
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a29
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a30
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a31
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a32
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a33
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a34
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a35
     -> ComponentSpec comparable (Ecs36 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36) a36
     -> componentSpecs
    )
    -> componentSpecs
components36 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs36 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs36 ecs) ->
                    Ecs36
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        }
            }
        )


{-| An ecs model type with 37 component types.
-}
type Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37
    = Ecs37
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        }


{-| An ecs specification with 37 component types.
-}
spec37 : Spec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37)
spec37 =
    Internal.Spec
        { empty =
            Ecs37
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                }
        , clear =
            \id (Ecs37 ecs) ->
                Ecs37
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    }
        , isEmpty =
            \(Ecs37 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
        , componentCount =
            \(Ecs37 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
        , ids =
            \(Ecs37 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs37 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
        }


{-| Create component specifications for an ecs with 37 component types.
-}
components37 :
    (ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a1
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a2
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a3
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a4
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a5
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a6
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a7
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a8
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a9
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a10
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a11
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a12
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a13
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a14
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a15
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a16
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a17
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a18
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a19
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a20
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a21
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a22
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a23
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a24
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a25
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a26
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a27
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a28
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a29
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a30
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a31
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a32
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a33
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a34
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a35
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a36
     -> ComponentSpec comparable (Ecs37 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37) a37
     -> componentSpecs
    )
    -> componentSpecs
components37 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs37 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs37 ecs) ->
                    Ecs37
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        }
            }
        )


{-| An ecs model type with 38 component types.
-}
type Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38
    = Ecs38
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        }


{-| An ecs specification with 38 component types.
-}
spec38 : Spec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38)
spec38 =
    Internal.Spec
        { empty =
            Ecs38
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                }
        , clear =
            \id (Ecs38 ecs) ->
                Ecs38
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    }
        , isEmpty =
            \(Ecs38 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
        , componentCount =
            \(Ecs38 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
        , ids =
            \(Ecs38 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs38 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
        }


{-| Create component specifications for an ecs with 38 component types.
-}
components38 :
    (ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a1
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a2
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a3
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a4
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a5
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a6
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a7
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a8
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a9
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a10
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a11
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a12
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a13
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a14
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a15
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a16
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a17
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a18
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a19
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a20
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a21
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a22
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a23
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a24
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a25
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a26
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a27
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a28
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a29
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a30
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a31
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a32
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a33
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a34
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a35
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a36
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a37
     -> ComponentSpec comparable (Ecs38 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38) a38
     -> componentSpecs
    )
    -> componentSpecs
components38 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs38 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs38 ecs) ->
                    Ecs38
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        }
            }
        )


{-| An ecs model type with 39 component types.
-}
type Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39
    = Ecs39
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        }


{-| An ecs specification with 39 component types.
-}
spec39 : Spec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39)
spec39 =
    Internal.Spec
        { empty =
            Ecs39
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                }
        , clear =
            \id (Ecs39 ecs) ->
                Ecs39
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    }
        , isEmpty =
            \(Ecs39 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
        , componentCount =
            \(Ecs39 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
        , ids =
            \(Ecs39 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs39 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
        }


{-| Create component specifications for an ecs with 39 component types.
-}
components39 :
    (ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a1
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a2
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a3
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a4
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a5
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a6
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a7
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a8
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a9
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a10
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a11
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a12
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a13
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a14
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a15
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a16
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a17
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a18
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a19
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a20
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a21
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a22
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a23
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a24
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a25
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a26
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a27
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a28
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a29
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a30
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a31
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a32
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a33
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a34
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a35
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a36
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a37
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a38
     -> ComponentSpec comparable (Ecs39 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39) a39
     -> componentSpecs
    )
    -> componentSpecs
components39 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs39 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs39 ecs) ->
                    Ecs39
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        }
            }
        )


{-| An ecs model type with 40 component types.
-}
type Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40
    = Ecs40
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        , data40 : Dict comparable a40
        }


{-| An ecs specification with 40 component types.
-}
spec40 : Spec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40)
spec40 =
    Internal.Spec
        { empty =
            Ecs40
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                , data40 = Dict.empty
                }
        , clear =
            \id (Ecs40 ecs) ->
                Ecs40
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    , data40 = Dict.remove id ecs.data40
                    }
        , isEmpty =
            \(Ecs40 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
                    && Dict.isEmpty ecs.data40
        , componentCount =
            \(Ecs40 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
                    + Dict.size ecs.data40
        , ids =
            \(Ecs40 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                , Dict.keys ecs.data40
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs40 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
                    || Dict.member id ecs.data40
        }


{-| Create component specifications for an ecs with 40 component types.
-}
components40 :
    (ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a1
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a2
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a3
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a4
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a5
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a6
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a7
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a8
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a9
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a10
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a11
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a12
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a13
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a14
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a15
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a16
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a17
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a18
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a19
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a20
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a21
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a22
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a23
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a24
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a25
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a26
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a27
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a28
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a29
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a30
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a31
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a32
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a33
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a34
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a35
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a36
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a37
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a38
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a39
     -> ComponentSpec comparable (Ecs40 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40) a40
     -> componentSpecs
    )
    -> componentSpecs
components40 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        , data40 = ecs.data40
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs40 ecs) -> ecs.data40
            , update =
                \updateFn (Ecs40 ecs) ->
                    Ecs40
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = updateFn ecs.data40
                        }
            }
        )


{-| An ecs model type with 41 component types.
-}
type Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41
    = Ecs41
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        , data40 : Dict comparable a40
        , data41 : Dict comparable a41
        }


{-| An ecs specification with 41 component types.
-}
spec41 : Spec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41)
spec41 =
    Internal.Spec
        { empty =
            Ecs41
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                , data40 = Dict.empty
                , data41 = Dict.empty
                }
        , clear =
            \id (Ecs41 ecs) ->
                Ecs41
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    , data40 = Dict.remove id ecs.data40
                    , data41 = Dict.remove id ecs.data41
                    }
        , isEmpty =
            \(Ecs41 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
                    && Dict.isEmpty ecs.data40
                    && Dict.isEmpty ecs.data41
        , componentCount =
            \(Ecs41 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
                    + Dict.size ecs.data40
                    + Dict.size ecs.data41
        , ids =
            \(Ecs41 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                , Dict.keys ecs.data40
                , Dict.keys ecs.data41
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs41 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
                    || Dict.member id ecs.data40
                    || Dict.member id ecs.data41
        }


{-| Create component specifications for an ecs with 41 component types.
-}
components41 :
    (ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a1
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a2
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a3
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a4
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a5
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a6
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a7
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a8
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a9
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a10
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a11
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a12
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a13
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a14
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a15
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a16
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a17
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a18
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a19
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a20
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a21
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a22
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a23
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a24
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a25
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a26
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a27
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a28
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a29
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a30
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a31
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a32
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a33
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a34
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a35
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a36
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a37
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a38
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a39
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a40
     -> ComponentSpec comparable (Ecs41 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41) a41
     -> componentSpecs
    )
    -> componentSpecs
components41 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data40
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = updateFn ecs.data40
                        , data41 = ecs.data41
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs41 ecs) -> ecs.data41
            , update =
                \updateFn (Ecs41 ecs) ->
                    Ecs41
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = updateFn ecs.data41
                        }
            }
        )


{-| An ecs model type with 42 component types.
-}
type Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42
    = Ecs42
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        , data40 : Dict comparable a40
        , data41 : Dict comparable a41
        , data42 : Dict comparable a42
        }


{-| An ecs specification with 42 component types.
-}
spec42 : Spec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42)
spec42 =
    Internal.Spec
        { empty =
            Ecs42
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                , data40 = Dict.empty
                , data41 = Dict.empty
                , data42 = Dict.empty
                }
        , clear =
            \id (Ecs42 ecs) ->
                Ecs42
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    , data40 = Dict.remove id ecs.data40
                    , data41 = Dict.remove id ecs.data41
                    , data42 = Dict.remove id ecs.data42
                    }
        , isEmpty =
            \(Ecs42 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
                    && Dict.isEmpty ecs.data40
                    && Dict.isEmpty ecs.data41
                    && Dict.isEmpty ecs.data42
        , componentCount =
            \(Ecs42 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
                    + Dict.size ecs.data40
                    + Dict.size ecs.data41
                    + Dict.size ecs.data42
        , ids =
            \(Ecs42 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                , Dict.keys ecs.data40
                , Dict.keys ecs.data41
                , Dict.keys ecs.data42
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs42 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
                    || Dict.member id ecs.data40
                    || Dict.member id ecs.data41
                    || Dict.member id ecs.data42
        }


{-| Create component specifications for an ecs with 42 component types.
-}
components42 :
    (ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a1
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a2
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a3
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a4
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a5
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a6
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a7
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a8
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a9
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a10
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a11
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a12
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a13
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a14
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a15
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a16
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a17
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a18
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a19
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a20
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a21
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a22
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a23
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a24
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a25
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a26
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a27
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a28
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a29
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a30
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a31
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a32
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a33
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a34
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a35
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a36
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a37
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a38
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a39
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a40
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a41
     -> ComponentSpec comparable (Ecs42 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42) a42
     -> componentSpecs
    )
    -> componentSpecs
components42 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data40
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = updateFn ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data41
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = updateFn ecs.data41
                        , data42 = ecs.data42
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs42 ecs) -> ecs.data42
            , update =
                \updateFn (Ecs42 ecs) ->
                    Ecs42
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = updateFn ecs.data42
                        }
            }
        )


{-| An ecs model type with 43 component types.
-}
type Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43
    = Ecs43
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        , data40 : Dict comparable a40
        , data41 : Dict comparable a41
        , data42 : Dict comparable a42
        , data43 : Dict comparable a43
        }


{-| An ecs specification with 43 component types.
-}
spec43 : Spec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43)
spec43 =
    Internal.Spec
        { empty =
            Ecs43
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                , data40 = Dict.empty
                , data41 = Dict.empty
                , data42 = Dict.empty
                , data43 = Dict.empty
                }
        , clear =
            \id (Ecs43 ecs) ->
                Ecs43
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    , data40 = Dict.remove id ecs.data40
                    , data41 = Dict.remove id ecs.data41
                    , data42 = Dict.remove id ecs.data42
                    , data43 = Dict.remove id ecs.data43
                    }
        , isEmpty =
            \(Ecs43 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
                    && Dict.isEmpty ecs.data40
                    && Dict.isEmpty ecs.data41
                    && Dict.isEmpty ecs.data42
                    && Dict.isEmpty ecs.data43
        , componentCount =
            \(Ecs43 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
                    + Dict.size ecs.data40
                    + Dict.size ecs.data41
                    + Dict.size ecs.data42
                    + Dict.size ecs.data43
        , ids =
            \(Ecs43 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                , Dict.keys ecs.data40
                , Dict.keys ecs.data41
                , Dict.keys ecs.data42
                , Dict.keys ecs.data43
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs43 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
                    || Dict.member id ecs.data40
                    || Dict.member id ecs.data41
                    || Dict.member id ecs.data42
                    || Dict.member id ecs.data43
        }


{-| Create component specifications for an ecs with 43 component types.
-}
components43 :
    (ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a1
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a2
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a3
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a4
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a5
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a6
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a7
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a8
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a9
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a10
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a11
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a12
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a13
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a14
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a15
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a16
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a17
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a18
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a19
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a20
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a21
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a22
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a23
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a24
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a25
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a26
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a27
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a28
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a29
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a30
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a31
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a32
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a33
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a34
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a35
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a36
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a37
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a38
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a39
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a40
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a41
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a42
     -> ComponentSpec comparable (Ecs43 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43) a43
     -> componentSpecs
    )
    -> componentSpecs
components43 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data40
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = updateFn ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data41
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = updateFn ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data42
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = updateFn ecs.data42
                        , data43 = ecs.data43
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs43 ecs) -> ecs.data43
            , update =
                \updateFn (Ecs43 ecs) ->
                    Ecs43
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = updateFn ecs.data43
                        }
            }
        )


{-| An ecs model type with 44 component types.
-}
type Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44
    = Ecs44
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        , data40 : Dict comparable a40
        , data41 : Dict comparable a41
        , data42 : Dict comparable a42
        , data43 : Dict comparable a43
        , data44 : Dict comparable a44
        }


{-| An ecs specification with 44 component types.
-}
spec44 : Spec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44)
spec44 =
    Internal.Spec
        { empty =
            Ecs44
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                , data40 = Dict.empty
                , data41 = Dict.empty
                , data42 = Dict.empty
                , data43 = Dict.empty
                , data44 = Dict.empty
                }
        , clear =
            \id (Ecs44 ecs) ->
                Ecs44
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    , data40 = Dict.remove id ecs.data40
                    , data41 = Dict.remove id ecs.data41
                    , data42 = Dict.remove id ecs.data42
                    , data43 = Dict.remove id ecs.data43
                    , data44 = Dict.remove id ecs.data44
                    }
        , isEmpty =
            \(Ecs44 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
                    && Dict.isEmpty ecs.data40
                    && Dict.isEmpty ecs.data41
                    && Dict.isEmpty ecs.data42
                    && Dict.isEmpty ecs.data43
                    && Dict.isEmpty ecs.data44
        , componentCount =
            \(Ecs44 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
                    + Dict.size ecs.data40
                    + Dict.size ecs.data41
                    + Dict.size ecs.data42
                    + Dict.size ecs.data43
                    + Dict.size ecs.data44
        , ids =
            \(Ecs44 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                , Dict.keys ecs.data40
                , Dict.keys ecs.data41
                , Dict.keys ecs.data42
                , Dict.keys ecs.data43
                , Dict.keys ecs.data44
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs44 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
                    || Dict.member id ecs.data40
                    || Dict.member id ecs.data41
                    || Dict.member id ecs.data42
                    || Dict.member id ecs.data43
                    || Dict.member id ecs.data44
        }


{-| Create component specifications for an ecs with 44 component types.
-}
components44 :
    (ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a1
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a2
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a3
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a4
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a5
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a6
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a7
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a8
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a9
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a10
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a11
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a12
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a13
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a14
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a15
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a16
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a17
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a18
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a19
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a20
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a21
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a22
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a23
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a24
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a25
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a26
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a27
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a28
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a29
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a30
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a31
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a32
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a33
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a34
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a35
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a36
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a37
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a38
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a39
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a40
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a41
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a42
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a43
     -> ComponentSpec comparable (Ecs44 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44) a44
     -> componentSpecs
    )
    -> componentSpecs
components44 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data40
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = updateFn ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data41
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = updateFn ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data42
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = updateFn ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data43
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = updateFn ecs.data43
                        , data44 = ecs.data44
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs44 ecs) -> ecs.data44
            , update =
                \updateFn (Ecs44 ecs) ->
                    Ecs44
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = updateFn ecs.data44
                        }
            }
        )


{-| An ecs model type with 45 component types.
-}
type Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45
    = Ecs45
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        , data40 : Dict comparable a40
        , data41 : Dict comparable a41
        , data42 : Dict comparable a42
        , data43 : Dict comparable a43
        , data44 : Dict comparable a44
        , data45 : Dict comparable a45
        }


{-| An ecs specification with 45 component types.
-}
spec45 : Spec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45)
spec45 =
    Internal.Spec
        { empty =
            Ecs45
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                , data40 = Dict.empty
                , data41 = Dict.empty
                , data42 = Dict.empty
                , data43 = Dict.empty
                , data44 = Dict.empty
                , data45 = Dict.empty
                }
        , clear =
            \id (Ecs45 ecs) ->
                Ecs45
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    , data40 = Dict.remove id ecs.data40
                    , data41 = Dict.remove id ecs.data41
                    , data42 = Dict.remove id ecs.data42
                    , data43 = Dict.remove id ecs.data43
                    , data44 = Dict.remove id ecs.data44
                    , data45 = Dict.remove id ecs.data45
                    }
        , isEmpty =
            \(Ecs45 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
                    && Dict.isEmpty ecs.data40
                    && Dict.isEmpty ecs.data41
                    && Dict.isEmpty ecs.data42
                    && Dict.isEmpty ecs.data43
                    && Dict.isEmpty ecs.data44
                    && Dict.isEmpty ecs.data45
        , componentCount =
            \(Ecs45 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
                    + Dict.size ecs.data40
                    + Dict.size ecs.data41
                    + Dict.size ecs.data42
                    + Dict.size ecs.data43
                    + Dict.size ecs.data44
                    + Dict.size ecs.data45
        , ids =
            \(Ecs45 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                , Dict.keys ecs.data40
                , Dict.keys ecs.data41
                , Dict.keys ecs.data42
                , Dict.keys ecs.data43
                , Dict.keys ecs.data44
                , Dict.keys ecs.data45
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs45 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
                    || Dict.member id ecs.data40
                    || Dict.member id ecs.data41
                    || Dict.member id ecs.data42
                    || Dict.member id ecs.data43
                    || Dict.member id ecs.data44
                    || Dict.member id ecs.data45
        }


{-| Create component specifications for an ecs with 45 component types.
-}
components45 :
    (ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a1
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a2
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a3
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a4
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a5
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a6
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a7
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a8
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a9
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a10
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a11
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a12
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a13
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a14
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a15
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a16
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a17
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a18
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a19
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a20
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a21
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a22
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a23
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a24
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a25
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a26
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a27
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a28
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a29
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a30
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a31
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a32
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a33
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a34
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a35
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a36
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a37
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a38
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a39
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a40
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a41
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a42
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a43
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a44
     -> ComponentSpec comparable (Ecs45 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45) a45
     -> componentSpecs
    )
    -> componentSpecs
components45 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data40
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = updateFn ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data41
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = updateFn ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data42
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = updateFn ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data43
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = updateFn ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data44
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = updateFn ecs.data44
                        , data45 = ecs.data45
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs45 ecs) -> ecs.data45
            , update =
                \updateFn (Ecs45 ecs) ->
                    Ecs45
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = updateFn ecs.data45
                        }
            }
        )


{-| An ecs model type with 46 component types.
-}
type Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46
    = Ecs46
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        , data40 : Dict comparable a40
        , data41 : Dict comparable a41
        , data42 : Dict comparable a42
        , data43 : Dict comparable a43
        , data44 : Dict comparable a44
        , data45 : Dict comparable a45
        , data46 : Dict comparable a46
        }


{-| An ecs specification with 46 component types.
-}
spec46 : Spec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46)
spec46 =
    Internal.Spec
        { empty =
            Ecs46
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                , data40 = Dict.empty
                , data41 = Dict.empty
                , data42 = Dict.empty
                , data43 = Dict.empty
                , data44 = Dict.empty
                , data45 = Dict.empty
                , data46 = Dict.empty
                }
        , clear =
            \id (Ecs46 ecs) ->
                Ecs46
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    , data40 = Dict.remove id ecs.data40
                    , data41 = Dict.remove id ecs.data41
                    , data42 = Dict.remove id ecs.data42
                    , data43 = Dict.remove id ecs.data43
                    , data44 = Dict.remove id ecs.data44
                    , data45 = Dict.remove id ecs.data45
                    , data46 = Dict.remove id ecs.data46
                    }
        , isEmpty =
            \(Ecs46 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
                    && Dict.isEmpty ecs.data40
                    && Dict.isEmpty ecs.data41
                    && Dict.isEmpty ecs.data42
                    && Dict.isEmpty ecs.data43
                    && Dict.isEmpty ecs.data44
                    && Dict.isEmpty ecs.data45
                    && Dict.isEmpty ecs.data46
        , componentCount =
            \(Ecs46 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
                    + Dict.size ecs.data40
                    + Dict.size ecs.data41
                    + Dict.size ecs.data42
                    + Dict.size ecs.data43
                    + Dict.size ecs.data44
                    + Dict.size ecs.data45
                    + Dict.size ecs.data46
        , ids =
            \(Ecs46 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                , Dict.keys ecs.data40
                , Dict.keys ecs.data41
                , Dict.keys ecs.data42
                , Dict.keys ecs.data43
                , Dict.keys ecs.data44
                , Dict.keys ecs.data45
                , Dict.keys ecs.data46
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs46 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
                    || Dict.member id ecs.data40
                    || Dict.member id ecs.data41
                    || Dict.member id ecs.data42
                    || Dict.member id ecs.data43
                    || Dict.member id ecs.data44
                    || Dict.member id ecs.data45
                    || Dict.member id ecs.data46
        }


{-| Create component specifications for an ecs with 46 component types.
-}
components46 :
    (ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a1
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a2
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a3
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a4
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a5
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a6
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a7
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a8
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a9
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a10
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a11
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a12
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a13
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a14
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a15
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a16
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a17
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a18
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a19
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a20
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a21
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a22
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a23
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a24
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a25
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a26
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a27
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a28
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a29
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a30
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a31
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a32
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a33
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a34
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a35
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a36
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a37
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a38
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a39
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a40
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a41
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a42
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a43
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a44
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a45
     -> ComponentSpec comparable (Ecs46 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46) a46
     -> componentSpecs
    )
    -> componentSpecs
components46 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data40
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = updateFn ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data41
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = updateFn ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data42
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = updateFn ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data43
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = updateFn ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data44
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = updateFn ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data45
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = updateFn ecs.data45
                        , data46 = ecs.data46
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs46 ecs) -> ecs.data46
            , update =
                \updateFn (Ecs46 ecs) ->
                    Ecs46
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = updateFn ecs.data46
                        }
            }
        )


{-| An ecs model type with 47 component types.
-}
type Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47
    = Ecs47
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        , data40 : Dict comparable a40
        , data41 : Dict comparable a41
        , data42 : Dict comparable a42
        , data43 : Dict comparable a43
        , data44 : Dict comparable a44
        , data45 : Dict comparable a45
        , data46 : Dict comparable a46
        , data47 : Dict comparable a47
        }


{-| An ecs specification with 47 component types.
-}
spec47 : Spec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47)
spec47 =
    Internal.Spec
        { empty =
            Ecs47
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                , data40 = Dict.empty
                , data41 = Dict.empty
                , data42 = Dict.empty
                , data43 = Dict.empty
                , data44 = Dict.empty
                , data45 = Dict.empty
                , data46 = Dict.empty
                , data47 = Dict.empty
                }
        , clear =
            \id (Ecs47 ecs) ->
                Ecs47
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    , data40 = Dict.remove id ecs.data40
                    , data41 = Dict.remove id ecs.data41
                    , data42 = Dict.remove id ecs.data42
                    , data43 = Dict.remove id ecs.data43
                    , data44 = Dict.remove id ecs.data44
                    , data45 = Dict.remove id ecs.data45
                    , data46 = Dict.remove id ecs.data46
                    , data47 = Dict.remove id ecs.data47
                    }
        , isEmpty =
            \(Ecs47 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
                    && Dict.isEmpty ecs.data40
                    && Dict.isEmpty ecs.data41
                    && Dict.isEmpty ecs.data42
                    && Dict.isEmpty ecs.data43
                    && Dict.isEmpty ecs.data44
                    && Dict.isEmpty ecs.data45
                    && Dict.isEmpty ecs.data46
                    && Dict.isEmpty ecs.data47
        , componentCount =
            \(Ecs47 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
                    + Dict.size ecs.data40
                    + Dict.size ecs.data41
                    + Dict.size ecs.data42
                    + Dict.size ecs.data43
                    + Dict.size ecs.data44
                    + Dict.size ecs.data45
                    + Dict.size ecs.data46
                    + Dict.size ecs.data47
        , ids =
            \(Ecs47 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                , Dict.keys ecs.data40
                , Dict.keys ecs.data41
                , Dict.keys ecs.data42
                , Dict.keys ecs.data43
                , Dict.keys ecs.data44
                , Dict.keys ecs.data45
                , Dict.keys ecs.data46
                , Dict.keys ecs.data47
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs47 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
                    || Dict.member id ecs.data40
                    || Dict.member id ecs.data41
                    || Dict.member id ecs.data42
                    || Dict.member id ecs.data43
                    || Dict.member id ecs.data44
                    || Dict.member id ecs.data45
                    || Dict.member id ecs.data46
                    || Dict.member id ecs.data47
        }


{-| Create component specifications for an ecs with 47 component types.
-}
components47 :
    (ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a1
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a2
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a3
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a4
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a5
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a6
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a7
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a8
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a9
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a10
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a11
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a12
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a13
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a14
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a15
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a16
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a17
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a18
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a19
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a20
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a21
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a22
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a23
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a24
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a25
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a26
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a27
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a28
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a29
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a30
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a31
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a32
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a33
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a34
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a35
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a36
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a37
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a38
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a39
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a40
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a41
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a42
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a43
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a44
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a45
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a46
     -> ComponentSpec comparable (Ecs47 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47) a47
     -> componentSpecs
    )
    -> componentSpecs
components47 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data40
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = updateFn ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data41
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = updateFn ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data42
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = updateFn ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data43
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = updateFn ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data44
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = updateFn ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data45
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = updateFn ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data46
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = updateFn ecs.data46
                        , data47 = ecs.data47
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs47 ecs) -> ecs.data47
            , update =
                \updateFn (Ecs47 ecs) ->
                    Ecs47
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = updateFn ecs.data47
                        }
            }
        )


{-| An ecs model type with 48 component types.
-}
type Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48
    = Ecs48
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        , data40 : Dict comparable a40
        , data41 : Dict comparable a41
        , data42 : Dict comparable a42
        , data43 : Dict comparable a43
        , data44 : Dict comparable a44
        , data45 : Dict comparable a45
        , data46 : Dict comparable a46
        , data47 : Dict comparable a47
        , data48 : Dict comparable a48
        }


{-| An ecs specification with 48 component types.
-}
spec48 : Spec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48)
spec48 =
    Internal.Spec
        { empty =
            Ecs48
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                , data40 = Dict.empty
                , data41 = Dict.empty
                , data42 = Dict.empty
                , data43 = Dict.empty
                , data44 = Dict.empty
                , data45 = Dict.empty
                , data46 = Dict.empty
                , data47 = Dict.empty
                , data48 = Dict.empty
                }
        , clear =
            \id (Ecs48 ecs) ->
                Ecs48
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    , data40 = Dict.remove id ecs.data40
                    , data41 = Dict.remove id ecs.data41
                    , data42 = Dict.remove id ecs.data42
                    , data43 = Dict.remove id ecs.data43
                    , data44 = Dict.remove id ecs.data44
                    , data45 = Dict.remove id ecs.data45
                    , data46 = Dict.remove id ecs.data46
                    , data47 = Dict.remove id ecs.data47
                    , data48 = Dict.remove id ecs.data48
                    }
        , isEmpty =
            \(Ecs48 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
                    && Dict.isEmpty ecs.data40
                    && Dict.isEmpty ecs.data41
                    && Dict.isEmpty ecs.data42
                    && Dict.isEmpty ecs.data43
                    && Dict.isEmpty ecs.data44
                    && Dict.isEmpty ecs.data45
                    && Dict.isEmpty ecs.data46
                    && Dict.isEmpty ecs.data47
                    && Dict.isEmpty ecs.data48
        , componentCount =
            \(Ecs48 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
                    + Dict.size ecs.data40
                    + Dict.size ecs.data41
                    + Dict.size ecs.data42
                    + Dict.size ecs.data43
                    + Dict.size ecs.data44
                    + Dict.size ecs.data45
                    + Dict.size ecs.data46
                    + Dict.size ecs.data47
                    + Dict.size ecs.data48
        , ids =
            \(Ecs48 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                , Dict.keys ecs.data40
                , Dict.keys ecs.data41
                , Dict.keys ecs.data42
                , Dict.keys ecs.data43
                , Dict.keys ecs.data44
                , Dict.keys ecs.data45
                , Dict.keys ecs.data46
                , Dict.keys ecs.data47
                , Dict.keys ecs.data48
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs48 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
                    || Dict.member id ecs.data40
                    || Dict.member id ecs.data41
                    || Dict.member id ecs.data42
                    || Dict.member id ecs.data43
                    || Dict.member id ecs.data44
                    || Dict.member id ecs.data45
                    || Dict.member id ecs.data46
                    || Dict.member id ecs.data47
                    || Dict.member id ecs.data48
        }


{-| Create component specifications for an ecs with 48 component types.
-}
components48 :
    (ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a1
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a2
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a3
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a4
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a5
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a6
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a7
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a8
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a9
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a10
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a11
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a12
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a13
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a14
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a15
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a16
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a17
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a18
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a19
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a20
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a21
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a22
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a23
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a24
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a25
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a26
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a27
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a28
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a29
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a30
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a31
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a32
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a33
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a34
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a35
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a36
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a37
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a38
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a39
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a40
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a41
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a42
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a43
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a44
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a45
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a46
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a47
     -> ComponentSpec comparable (Ecs48 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48) a48
     -> componentSpecs
    )
    -> componentSpecs
components48 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data40
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = updateFn ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data41
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = updateFn ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data42
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = updateFn ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data43
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = updateFn ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data44
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = updateFn ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data45
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = updateFn ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data46
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = updateFn ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data47
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = updateFn ecs.data47
                        , data48 = ecs.data48
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs48 ecs) -> ecs.data48
            , update =
                \updateFn (Ecs48 ecs) ->
                    Ecs48
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = updateFn ecs.data48
                        }
            }
        )


{-| An ecs model type with 49 component types.
-}
type Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49
    = Ecs49
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        , data40 : Dict comparable a40
        , data41 : Dict comparable a41
        , data42 : Dict comparable a42
        , data43 : Dict comparable a43
        , data44 : Dict comparable a44
        , data45 : Dict comparable a45
        , data46 : Dict comparable a46
        , data47 : Dict comparable a47
        , data48 : Dict comparable a48
        , data49 : Dict comparable a49
        }


{-| An ecs specification with 49 component types.
-}
spec49 : Spec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49)
spec49 =
    Internal.Spec
        { empty =
            Ecs49
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                , data40 = Dict.empty
                , data41 = Dict.empty
                , data42 = Dict.empty
                , data43 = Dict.empty
                , data44 = Dict.empty
                , data45 = Dict.empty
                , data46 = Dict.empty
                , data47 = Dict.empty
                , data48 = Dict.empty
                , data49 = Dict.empty
                }
        , clear =
            \id (Ecs49 ecs) ->
                Ecs49
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    , data40 = Dict.remove id ecs.data40
                    , data41 = Dict.remove id ecs.data41
                    , data42 = Dict.remove id ecs.data42
                    , data43 = Dict.remove id ecs.data43
                    , data44 = Dict.remove id ecs.data44
                    , data45 = Dict.remove id ecs.data45
                    , data46 = Dict.remove id ecs.data46
                    , data47 = Dict.remove id ecs.data47
                    , data48 = Dict.remove id ecs.data48
                    , data49 = Dict.remove id ecs.data49
                    }
        , isEmpty =
            \(Ecs49 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
                    && Dict.isEmpty ecs.data40
                    && Dict.isEmpty ecs.data41
                    && Dict.isEmpty ecs.data42
                    && Dict.isEmpty ecs.data43
                    && Dict.isEmpty ecs.data44
                    && Dict.isEmpty ecs.data45
                    && Dict.isEmpty ecs.data46
                    && Dict.isEmpty ecs.data47
                    && Dict.isEmpty ecs.data48
                    && Dict.isEmpty ecs.data49
        , componentCount =
            \(Ecs49 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
                    + Dict.size ecs.data40
                    + Dict.size ecs.data41
                    + Dict.size ecs.data42
                    + Dict.size ecs.data43
                    + Dict.size ecs.data44
                    + Dict.size ecs.data45
                    + Dict.size ecs.data46
                    + Dict.size ecs.data47
                    + Dict.size ecs.data48
                    + Dict.size ecs.data49
        , ids =
            \(Ecs49 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                , Dict.keys ecs.data40
                , Dict.keys ecs.data41
                , Dict.keys ecs.data42
                , Dict.keys ecs.data43
                , Dict.keys ecs.data44
                , Dict.keys ecs.data45
                , Dict.keys ecs.data46
                , Dict.keys ecs.data47
                , Dict.keys ecs.data48
                , Dict.keys ecs.data49
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs49 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
                    || Dict.member id ecs.data40
                    || Dict.member id ecs.data41
                    || Dict.member id ecs.data42
                    || Dict.member id ecs.data43
                    || Dict.member id ecs.data44
                    || Dict.member id ecs.data45
                    || Dict.member id ecs.data46
                    || Dict.member id ecs.data47
                    || Dict.member id ecs.data48
                    || Dict.member id ecs.data49
        }


{-| Create component specifications for an ecs with 49 component types.
-}
components49 :
    (ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a1
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a2
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a3
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a4
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a5
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a6
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a7
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a8
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a9
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a10
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a11
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a12
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a13
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a14
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a15
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a16
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a17
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a18
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a19
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a20
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a21
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a22
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a23
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a24
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a25
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a26
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a27
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a28
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a29
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a30
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a31
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a32
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a33
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a34
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a35
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a36
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a37
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a38
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a39
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a40
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a41
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a42
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a43
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a44
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a45
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a46
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a47
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a48
     -> ComponentSpec comparable (Ecs49 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49) a49
     -> componentSpecs
    )
    -> componentSpecs
components49 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data40
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = updateFn ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data41
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = updateFn ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data42
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = updateFn ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data43
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = updateFn ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data44
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = updateFn ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data45
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = updateFn ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data46
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = updateFn ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data47
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = updateFn ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data48
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = updateFn ecs.data48
                        , data49 = ecs.data49
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs49 ecs) -> ecs.data49
            , update =
                \updateFn (Ecs49 ecs) ->
                    Ecs49
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = updateFn ecs.data49
                        }
            }
        )


{-| An ecs model type with 50 component types.
-}
type Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50
    = Ecs50
        { data1 : Dict comparable a1
        , data2 : Dict comparable a2
        , data3 : Dict comparable a3
        , data4 : Dict comparable a4
        , data5 : Dict comparable a5
        , data6 : Dict comparable a6
        , data7 : Dict comparable a7
        , data8 : Dict comparable a8
        , data9 : Dict comparable a9
        , data10 : Dict comparable a10
        , data11 : Dict comparable a11
        , data12 : Dict comparable a12
        , data13 : Dict comparable a13
        , data14 : Dict comparable a14
        , data15 : Dict comparable a15
        , data16 : Dict comparable a16
        , data17 : Dict comparable a17
        , data18 : Dict comparable a18
        , data19 : Dict comparable a19
        , data20 : Dict comparable a20
        , data21 : Dict comparable a21
        , data22 : Dict comparable a22
        , data23 : Dict comparable a23
        , data24 : Dict comparable a24
        , data25 : Dict comparable a25
        , data26 : Dict comparable a26
        , data27 : Dict comparable a27
        , data28 : Dict comparable a28
        , data29 : Dict comparable a29
        , data30 : Dict comparable a30
        , data31 : Dict comparable a31
        , data32 : Dict comparable a32
        , data33 : Dict comparable a33
        , data34 : Dict comparable a34
        , data35 : Dict comparable a35
        , data36 : Dict comparable a36
        , data37 : Dict comparable a37
        , data38 : Dict comparable a38
        , data39 : Dict comparable a39
        , data40 : Dict comparable a40
        , data41 : Dict comparable a41
        , data42 : Dict comparable a42
        , data43 : Dict comparable a43
        , data44 : Dict comparable a44
        , data45 : Dict comparable a45
        , data46 : Dict comparable a46
        , data47 : Dict comparable a47
        , data48 : Dict comparable a48
        , data49 : Dict comparable a49
        , data50 : Dict comparable a50
        }


{-| An ecs specification with 50 component types.
-}
spec50 : Spec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50)
spec50 =
    Internal.Spec
        { empty =
            Ecs50
                { data1 = Dict.empty
                , data2 = Dict.empty
                , data3 = Dict.empty
                , data4 = Dict.empty
                , data5 = Dict.empty
                , data6 = Dict.empty
                , data7 = Dict.empty
                , data8 = Dict.empty
                , data9 = Dict.empty
                , data10 = Dict.empty
                , data11 = Dict.empty
                , data12 = Dict.empty
                , data13 = Dict.empty
                , data14 = Dict.empty
                , data15 = Dict.empty
                , data16 = Dict.empty
                , data17 = Dict.empty
                , data18 = Dict.empty
                , data19 = Dict.empty
                , data20 = Dict.empty
                , data21 = Dict.empty
                , data22 = Dict.empty
                , data23 = Dict.empty
                , data24 = Dict.empty
                , data25 = Dict.empty
                , data26 = Dict.empty
                , data27 = Dict.empty
                , data28 = Dict.empty
                , data29 = Dict.empty
                , data30 = Dict.empty
                , data31 = Dict.empty
                , data32 = Dict.empty
                , data33 = Dict.empty
                , data34 = Dict.empty
                , data35 = Dict.empty
                , data36 = Dict.empty
                , data37 = Dict.empty
                , data38 = Dict.empty
                , data39 = Dict.empty
                , data40 = Dict.empty
                , data41 = Dict.empty
                , data42 = Dict.empty
                , data43 = Dict.empty
                , data44 = Dict.empty
                , data45 = Dict.empty
                , data46 = Dict.empty
                , data47 = Dict.empty
                , data48 = Dict.empty
                , data49 = Dict.empty
                , data50 = Dict.empty
                }
        , clear =
            \id (Ecs50 ecs) ->
                Ecs50
                    { data1 = Dict.remove id ecs.data1
                    , data2 = Dict.remove id ecs.data2
                    , data3 = Dict.remove id ecs.data3
                    , data4 = Dict.remove id ecs.data4
                    , data5 = Dict.remove id ecs.data5
                    , data6 = Dict.remove id ecs.data6
                    , data7 = Dict.remove id ecs.data7
                    , data8 = Dict.remove id ecs.data8
                    , data9 = Dict.remove id ecs.data9
                    , data10 = Dict.remove id ecs.data10
                    , data11 = Dict.remove id ecs.data11
                    , data12 = Dict.remove id ecs.data12
                    , data13 = Dict.remove id ecs.data13
                    , data14 = Dict.remove id ecs.data14
                    , data15 = Dict.remove id ecs.data15
                    , data16 = Dict.remove id ecs.data16
                    , data17 = Dict.remove id ecs.data17
                    , data18 = Dict.remove id ecs.data18
                    , data19 = Dict.remove id ecs.data19
                    , data20 = Dict.remove id ecs.data20
                    , data21 = Dict.remove id ecs.data21
                    , data22 = Dict.remove id ecs.data22
                    , data23 = Dict.remove id ecs.data23
                    , data24 = Dict.remove id ecs.data24
                    , data25 = Dict.remove id ecs.data25
                    , data26 = Dict.remove id ecs.data26
                    , data27 = Dict.remove id ecs.data27
                    , data28 = Dict.remove id ecs.data28
                    , data29 = Dict.remove id ecs.data29
                    , data30 = Dict.remove id ecs.data30
                    , data31 = Dict.remove id ecs.data31
                    , data32 = Dict.remove id ecs.data32
                    , data33 = Dict.remove id ecs.data33
                    , data34 = Dict.remove id ecs.data34
                    , data35 = Dict.remove id ecs.data35
                    , data36 = Dict.remove id ecs.data36
                    , data37 = Dict.remove id ecs.data37
                    , data38 = Dict.remove id ecs.data38
                    , data39 = Dict.remove id ecs.data39
                    , data40 = Dict.remove id ecs.data40
                    , data41 = Dict.remove id ecs.data41
                    , data42 = Dict.remove id ecs.data42
                    , data43 = Dict.remove id ecs.data43
                    , data44 = Dict.remove id ecs.data44
                    , data45 = Dict.remove id ecs.data45
                    , data46 = Dict.remove id ecs.data46
                    , data47 = Dict.remove id ecs.data47
                    , data48 = Dict.remove id ecs.data48
                    , data49 = Dict.remove id ecs.data49
                    , data50 = Dict.remove id ecs.data50
                    }
        , isEmpty =
            \(Ecs50 ecs) ->
                Dict.isEmpty ecs.data1
                    && Dict.isEmpty ecs.data2
                    && Dict.isEmpty ecs.data3
                    && Dict.isEmpty ecs.data4
                    && Dict.isEmpty ecs.data5
                    && Dict.isEmpty ecs.data6
                    && Dict.isEmpty ecs.data7
                    && Dict.isEmpty ecs.data8
                    && Dict.isEmpty ecs.data9
                    && Dict.isEmpty ecs.data10
                    && Dict.isEmpty ecs.data11
                    && Dict.isEmpty ecs.data12
                    && Dict.isEmpty ecs.data13
                    && Dict.isEmpty ecs.data14
                    && Dict.isEmpty ecs.data15
                    && Dict.isEmpty ecs.data16
                    && Dict.isEmpty ecs.data17
                    && Dict.isEmpty ecs.data18
                    && Dict.isEmpty ecs.data19
                    && Dict.isEmpty ecs.data20
                    && Dict.isEmpty ecs.data21
                    && Dict.isEmpty ecs.data22
                    && Dict.isEmpty ecs.data23
                    && Dict.isEmpty ecs.data24
                    && Dict.isEmpty ecs.data25
                    && Dict.isEmpty ecs.data26
                    && Dict.isEmpty ecs.data27
                    && Dict.isEmpty ecs.data28
                    && Dict.isEmpty ecs.data29
                    && Dict.isEmpty ecs.data30
                    && Dict.isEmpty ecs.data31
                    && Dict.isEmpty ecs.data32
                    && Dict.isEmpty ecs.data33
                    && Dict.isEmpty ecs.data34
                    && Dict.isEmpty ecs.data35
                    && Dict.isEmpty ecs.data36
                    && Dict.isEmpty ecs.data37
                    && Dict.isEmpty ecs.data38
                    && Dict.isEmpty ecs.data39
                    && Dict.isEmpty ecs.data40
                    && Dict.isEmpty ecs.data41
                    && Dict.isEmpty ecs.data42
                    && Dict.isEmpty ecs.data43
                    && Dict.isEmpty ecs.data44
                    && Dict.isEmpty ecs.data45
                    && Dict.isEmpty ecs.data46
                    && Dict.isEmpty ecs.data47
                    && Dict.isEmpty ecs.data48
                    && Dict.isEmpty ecs.data49
                    && Dict.isEmpty ecs.data50
        , componentCount =
            \(Ecs50 ecs) ->
                Dict.size ecs.data1
                    + Dict.size ecs.data2
                    + Dict.size ecs.data3
                    + Dict.size ecs.data4
                    + Dict.size ecs.data5
                    + Dict.size ecs.data6
                    + Dict.size ecs.data7
                    + Dict.size ecs.data8
                    + Dict.size ecs.data9
                    + Dict.size ecs.data10
                    + Dict.size ecs.data11
                    + Dict.size ecs.data12
                    + Dict.size ecs.data13
                    + Dict.size ecs.data14
                    + Dict.size ecs.data15
                    + Dict.size ecs.data16
                    + Dict.size ecs.data17
                    + Dict.size ecs.data18
                    + Dict.size ecs.data19
                    + Dict.size ecs.data20
                    + Dict.size ecs.data21
                    + Dict.size ecs.data22
                    + Dict.size ecs.data23
                    + Dict.size ecs.data24
                    + Dict.size ecs.data25
                    + Dict.size ecs.data26
                    + Dict.size ecs.data27
                    + Dict.size ecs.data28
                    + Dict.size ecs.data29
                    + Dict.size ecs.data30
                    + Dict.size ecs.data31
                    + Dict.size ecs.data32
                    + Dict.size ecs.data33
                    + Dict.size ecs.data34
                    + Dict.size ecs.data35
                    + Dict.size ecs.data36
                    + Dict.size ecs.data37
                    + Dict.size ecs.data38
                    + Dict.size ecs.data39
                    + Dict.size ecs.data40
                    + Dict.size ecs.data41
                    + Dict.size ecs.data42
                    + Dict.size ecs.data43
                    + Dict.size ecs.data44
                    + Dict.size ecs.data45
                    + Dict.size ecs.data46
                    + Dict.size ecs.data47
                    + Dict.size ecs.data48
                    + Dict.size ecs.data49
                    + Dict.size ecs.data50
        , ids =
            \(Ecs50 ecs) ->
                [ Dict.keys ecs.data1
                , Dict.keys ecs.data2
                , Dict.keys ecs.data3
                , Dict.keys ecs.data4
                , Dict.keys ecs.data5
                , Dict.keys ecs.data6
                , Dict.keys ecs.data7
                , Dict.keys ecs.data8
                , Dict.keys ecs.data9
                , Dict.keys ecs.data10
                , Dict.keys ecs.data11
                , Dict.keys ecs.data12
                , Dict.keys ecs.data13
                , Dict.keys ecs.data14
                , Dict.keys ecs.data15
                , Dict.keys ecs.data16
                , Dict.keys ecs.data17
                , Dict.keys ecs.data18
                , Dict.keys ecs.data19
                , Dict.keys ecs.data20
                , Dict.keys ecs.data21
                , Dict.keys ecs.data22
                , Dict.keys ecs.data23
                , Dict.keys ecs.data24
                , Dict.keys ecs.data25
                , Dict.keys ecs.data26
                , Dict.keys ecs.data27
                , Dict.keys ecs.data28
                , Dict.keys ecs.data29
                , Dict.keys ecs.data30
                , Dict.keys ecs.data31
                , Dict.keys ecs.data32
                , Dict.keys ecs.data33
                , Dict.keys ecs.data34
                , Dict.keys ecs.data35
                , Dict.keys ecs.data36
                , Dict.keys ecs.data37
                , Dict.keys ecs.data38
                , Dict.keys ecs.data39
                , Dict.keys ecs.data40
                , Dict.keys ecs.data41
                , Dict.keys ecs.data42
                , Dict.keys ecs.data43
                , Dict.keys ecs.data44
                , Dict.keys ecs.data45
                , Dict.keys ecs.data46
                , Dict.keys ecs.data47
                , Dict.keys ecs.data48
                , Dict.keys ecs.data49
                , Dict.keys ecs.data50
                ]
                    |> List.foldl
                        (\keys a ->
                            List.foldl (\key b -> Set.insert key b) a keys
                        )
                        Set.empty
        , member =
            \id (Ecs50 ecs) ->
                Dict.member id ecs.data1
                    || Dict.member id ecs.data2
                    || Dict.member id ecs.data3
                    || Dict.member id ecs.data4
                    || Dict.member id ecs.data5
                    || Dict.member id ecs.data6
                    || Dict.member id ecs.data7
                    || Dict.member id ecs.data8
                    || Dict.member id ecs.data9
                    || Dict.member id ecs.data10
                    || Dict.member id ecs.data11
                    || Dict.member id ecs.data12
                    || Dict.member id ecs.data13
                    || Dict.member id ecs.data14
                    || Dict.member id ecs.data15
                    || Dict.member id ecs.data16
                    || Dict.member id ecs.data17
                    || Dict.member id ecs.data18
                    || Dict.member id ecs.data19
                    || Dict.member id ecs.data20
                    || Dict.member id ecs.data21
                    || Dict.member id ecs.data22
                    || Dict.member id ecs.data23
                    || Dict.member id ecs.data24
                    || Dict.member id ecs.data25
                    || Dict.member id ecs.data26
                    || Dict.member id ecs.data27
                    || Dict.member id ecs.data28
                    || Dict.member id ecs.data29
                    || Dict.member id ecs.data30
                    || Dict.member id ecs.data31
                    || Dict.member id ecs.data32
                    || Dict.member id ecs.data33
                    || Dict.member id ecs.data34
                    || Dict.member id ecs.data35
                    || Dict.member id ecs.data36
                    || Dict.member id ecs.data37
                    || Dict.member id ecs.data38
                    || Dict.member id ecs.data39
                    || Dict.member id ecs.data40
                    || Dict.member id ecs.data41
                    || Dict.member id ecs.data42
                    || Dict.member id ecs.data43
                    || Dict.member id ecs.data44
                    || Dict.member id ecs.data45
                    || Dict.member id ecs.data46
                    || Dict.member id ecs.data47
                    || Dict.member id ecs.data48
                    || Dict.member id ecs.data49
                    || Dict.member id ecs.data50
        }


{-| Create component specifications for an ecs with 50 component types.
-}
components50 :
    (ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a1
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a2
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a3
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a4
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a5
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a6
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a7
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a8
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a9
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a10
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a11
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a12
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a13
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a14
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a15
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a16
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a17
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a18
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a19
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a20
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a21
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a22
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a23
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a24
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a25
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a26
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a27
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a28
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a29
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a30
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a31
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a32
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a33
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a34
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a35
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a36
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a37
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a38
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a39
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a40
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a41
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a42
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a43
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a44
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a45
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a46
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a47
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a48
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a49
     -> ComponentSpec comparable (Ecs50 comparable a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 a13 a14 a15 a16 a17 a18 a19 a20 a21 a22 a23 a24 a25 a26 a27 a28 a29 a30 a31 a32 a33 a34 a35 a36 a37 a38 a39 a40 a41 a42 a43 a44 a45 a46 a47 a48 a49 a50) a50
     -> componentSpecs
    )
    -> componentSpecs
components50 fn =
    fn
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data1
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = updateFn ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data2
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = updateFn ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data3
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = updateFn ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data4
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = updateFn ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data5
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = updateFn ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data6
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = updateFn ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data7
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = updateFn ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data8
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = updateFn ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data9
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = updateFn ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data10
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = updateFn ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data11
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = updateFn ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data12
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = updateFn ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data13
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = updateFn ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data14
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = updateFn ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data15
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = updateFn ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data16
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = updateFn ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data17
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = updateFn ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data18
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = updateFn ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data19
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = updateFn ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data20
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = updateFn ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data21
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = updateFn ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data22
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = updateFn ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data23
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = updateFn ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data24
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = updateFn ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data25
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = updateFn ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data26
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = updateFn ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data27
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = updateFn ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data28
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = updateFn ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data29
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = updateFn ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data30
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = updateFn ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data31
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = updateFn ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data32
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = updateFn ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data33
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = updateFn ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data34
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = updateFn ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data35
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = updateFn ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data36
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = updateFn ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data37
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = updateFn ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data38
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = updateFn ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data39
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = updateFn ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data40
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = updateFn ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data41
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = updateFn ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data42
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = updateFn ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data43
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = updateFn ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data44
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = updateFn ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data45
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = updateFn ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data46
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = updateFn ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data47
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = updateFn ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data48
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = updateFn ecs.data48
                        , data49 = ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data49
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = updateFn ecs.data49
                        , data50 = ecs.data50
                        }
            }
        )
        (Internal.ComponentSpec
            { get = \(Ecs50 ecs) -> ecs.data50
            , update =
                \updateFn (Ecs50 ecs) ->
                    Ecs50
                        { data1 = ecs.data1
                        , data2 = ecs.data2
                        , data3 = ecs.data3
                        , data4 = ecs.data4
                        , data5 = ecs.data5
                        , data6 = ecs.data6
                        , data7 = ecs.data7
                        , data8 = ecs.data8
                        , data9 = ecs.data9
                        , data10 = ecs.data10
                        , data11 = ecs.data11
                        , data12 = ecs.data12
                        , data13 = ecs.data13
                        , data14 = ecs.data14
                        , data15 = ecs.data15
                        , data16 = ecs.data16
                        , data17 = ecs.data17
                        , data18 = ecs.data18
                        , data19 = ecs.data19
                        , data20 = ecs.data20
                        , data21 = ecs.data21
                        , data22 = ecs.data22
                        , data23 = ecs.data23
                        , data24 = ecs.data24
                        , data25 = ecs.data25
                        , data26 = ecs.data26
                        , data27 = ecs.data27
                        , data28 = ecs.data28
                        , data29 = ecs.data29
                        , data30 = ecs.data30
                        , data31 = ecs.data31
                        , data32 = ecs.data32
                        , data33 = ecs.data33
                        , data34 = ecs.data34
                        , data35 = ecs.data35
                        , data36 = ecs.data36
                        , data37 = ecs.data37
                        , data38 = ecs.data38
                        , data39 = ecs.data39
                        , data40 = ecs.data40
                        , data41 = ecs.data41
                        , data42 = ecs.data42
                        , data43 = ecs.data43
                        , data44 = ecs.data44
                        , data45 = ecs.data45
                        , data46 = ecs.data46
                        , data47 = ecs.data47
                        , data48 = ecs.data48
                        , data49 = ecs.data49
                        , data50 = updateFn ecs.data50
                        }
            }
        )
